/****************************************************************************
** Date:2006.6.30 
** Author:ε
** Comment: Affine Combert 
****************************************************************************/

#include <stdio.h>
#include <malloc.h>
#include <math.h>
#include "level1.h"
#include "affine.h"

#define size 2

void affine_c(imElement *im, float r ,float size, int type)
{
  void MulVectorMatrix(FVECTOR2D v1,FMATRIX2D m,FVECTOR2D v2);

  RGB *before,*after; // žȲžRGB
  
  double rad;
  int x,y;            // žΥХåեΤѿ
  int bcx,bcy;        // ž濴ɸ
  int acx,acy;        // ž濴ɸ
  int width,height;   // ι⤵
  
  FMATRIX2D work;             // եѴѥޥȥå
  FVECTOR2D vector = {0,0,0}; // Ѵ٥
  FVECTOR2D v0,v1,v2,v3;
  
  bcx = im->width /2 ;      // žxɸ
  bcy = im->height /2 ;     // žyɸ

  rad = r/180 * M_PI;
  
  // type  1 ΤȤž

  if(type == 1){

  // žѤΥޥȥå

    work[0][0] = cosf(rad);  work[1][0] = -sinf(rad);  work[2][0] =  0;
    work[0][1] = sinf(rad);  work[1][1] =  cosf(rad);  work[2][1] =  0;
    work[0][2] = 0;          work[1][2] =  0;          work[2][2] =  1;
  }

  // type  2 ΤȤ̾(sizeˤѴΨ)

  else if(type == 2){

    // ̾ѤΥޥȥå

    work[0][0] = size;    work[1][0] =  0;       work[2][0] =  0;
    work[0][1] = 0;       work[1][1] =  size;    work[2][1] =  0;
    work[0][2] = 0;       work[1][2] =  0;       work[2][2] =  1;
  }

   //v0Ǥˤ 0 

  MulVectorMatrix(v0,work,vector);

  //v1Ǥ
  vector[0] = im->width; vector[1] = 0; vector[2] = 0;
  MulVectorMatrix(v1,work,vector);
  
  //v2Ǥ

  vector[0] = 0; vector[1] = im->height; vector[2] = 0;
  MulVectorMatrix(v2,work,vector);
  
  //v3Ǥ

  vector[0] = im->width; vector[1] = im->height; vector[2] = 0;
  MulVectorMatrix(v3,work,vector);
  
  // 줾ͤȤꡢ礭˺

  if(abs(v0[0] - v3[0]) > abs(v1[0] - v2[0]))
    width  = abs(v0[0] - v3[0]);
  else
    width  = abs(v1[0] - v2[0]);
  
  // 줾ͤȤꡢ礭˺

  if(abs(v0[1] - v3[1]) > abs(v1[1] - v2[1]))
    height = abs(v0[1] - v3[1]);
  else
    height = abs(v1[1] - v2[1]);
  
  acx = width  / 2 ;         // žxɸ
  acy = height / 2 ;         // žyɸ
  
  //Υʬ̤

  after  = (RGB *)malloc( width  * height * sizeof(RGB));

  //ѴΥǡ

  before = (RGB *)im->xim->data;
  
  for(y = -acy ; y < acy ; y++){
    for(x = -acx ; x < acx ; x++){
      vector[0] = x;
      vector[1] = y;
      vector[2] = 0;
      
      MulVectorMatrix(vector,work,vector);

      // Υǡ¸ߤʤν

      if((vector[0] + bcx < 0) ||(vector[0] + bcx > im->width)||
	 (vector[1] + bcy < 0) ||(vector[1] + bcy > im->height)){
	(after + (y + acy) * width + (x + acx))->red   = 0x00;
	(after + (y + acy) * width + (x + acx))->green = 0x00;
	(after + (y + acy) * width + (x + acx))->blue  = 0x00;
      }else{

	//Υǡ¸ߤ硢ޥԤ

	(after + (y + acy) * width + (x + acx))->red = 
	  (before + (int)(vector[1] + bcy) * im->width + (int)(vector[0] + bcx))->red;
	
	(after + (y + acy) * width + (x + acx))->green = 
	  (before + (int)(vector[1] + bcy) * im->width + (int)(vector[0] + bcx))->green;
	
	(after + (y + acy) * width + (x + acx))->blue = 
	  (before + (int)(vector[1] + bcy) * im->width + (int)(vector[0] + bcx))->blue;
      }
    }
  }
  
  //widthheightι

  im->width  = width;
  im->height = height;
  
  //dataι

  im->xim->data = (unsigned char*)after;
  im->xim->bytes_per_line = width * 3;
  free(before);
}

//եѴμ

void MulVectorMatrix(FVECTOR2D v1,FMATRIX2D m,FVECTOR2D v2){
  FVECTOR2D v;
  
  v[0] = m[0][0] * v2[0] +  m[1][0] * v2[1] +  m[2][0] * v2[2];
  v[1] = m[0][1] * v2[0] +  m[1][1] * v2[1] +  m[2][1] * v2[2];
  v[2] = m[0][2] * v2[0] +  m[1][2] * v2[1] +  m[2][2] * v2[2];
 
  //եѴ
  //                            | a b 0 | 
  //  [ x' y' 1 ]  =  [ x y 1 ] | c d 0 |
  //                            | e f 1 |
  //  x' = x*a + y*b + 1*0 
  //  y' = x*c + y*d + 1*0
  //  1  = x*e + y*f + 1*1
 
  // ֥å v Ƭ FVECTOR2DʬΥv1إԡ

  memcpy(v1,v,sizeof(FVECTOR2D));
}
